A Framework for Session Description Protocol (SDP) Attributes When Multiplexing
RFC 8859
Suhas Nandakumar
Cisco
170 West Tasman Drive
San Jose
CA
95134
United States of America
snandaku@cisco.com
May 2020
ART
MMUSIC
The purpose of this specification is to provide a framework for analyzing the multiplexing characteristics of Session Description Protocol (SDP) attributes when SDP is used to negotiate the usage of a single 5-tuple for sending and receiving media associated with multiple media descriptions.
This specification also categorizes the existing SDP attributes based on the framework described herein.
Introduction
SDP defines several attributes for capturing characteristics that apply to the individual media descriptions (described by "m=" lines) and the overall multimedia session. Typically, different media types (audio, video, etc.) described using different media descriptions represent separate RTP sessions that are carried over individual transport-layer flows. However, [RFC8843] defines a way to use a single address:port combination (BUNDLE address) for receiving media associated with multiple SDP media descriptions. This would, for example, allow the usage of a single set of Interactive Connectivity Establishment (ICE) [RFC8445] candidates for multiple media descriptions. This, in turn, has made it necessary to understand the interpretation and usage of the SDP attributes defined for the multiplexed media descriptions.
Given the number of SDP attributes registered with the [IANA] and the possibility of new attributes being defined in the future, there is need for a framework to analyze these attributes for their applicability in the transport multiplexing use cases.
The document starts with providing the motivation for requiring such a framework. This is followed by introduction to the SDP attribute analysis framework and procedures, following which several sections apply the framework to the SDP attributes registered with the [IANA].
Terminology
5-tuple:
A collection of the following values: source address, source port, destination address, destination port, and transport-layer protocol.
3GPP:
Third Generation Partnership Project; see https://www.3gpp.org for more information about this organization.
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Motivation
An effort to reduce the number of necessary transport-level flows is required because of the time and complications involved in setting up Secure Real-time Transport Protocol (SRTP) [RFC5763] transports for use by RTP based on ICE [RFC8445] and Datagram Transport Layer Security (DTLS). These procedures motivate conservation of ports bindings on the Network Address Translators (NATs).
This necessity has resulted in the definition of ways, such as that described in [RFC8843], to multiplex RTP over a single transport flow in order to preserve network resources such as port numbers. This imposes further restrictions on applicability of the SDP attributes as they are defined today.
The specific problem is that there are attribute combinations that make sense when specified on independent "m=" lines -- as with classical SDP -- that do not make sense when those "m=" lines are then multiplexed over the same transport. To give an obvious example, ICE permits each "m=" line to have an independently specified "ice-ufrag" attribute. However, if the media from multiple "m=" lines is multiplexed over the same ICE component, then the meaning of media-level "ice-ufrag" attributes becomes muddled.
At the time of writing this document, there are close to 250 SDP attributes registered with the [IANA], and more will be added in the future. There is no clearly defined procedure to establish the validity/applicability of these attributes when used with transport multiplexing.
SDP Attribute Analysis Framework
Attributes in an SDP session description can be defined at the session level, media level, or source level. Informally, there are various semantic groupings for these attributes. One such grouping could be as follows:
- Attributes related to media content such as media type, encoding schemes, and payload types.
- Attributes specifying media transport characteristics such as RTP/RTP Control Protocol (RTCP) port numbers, network addresses, and QoS.
- Metadata description attributes capturing session timing and origin information.
- Attributes establishing relationships between media descriptions, such as grouping framework [RFC5888].
The proposed framework analyzes the SDP attributes usage under multiplexing and assigns each SDP attribute to an appropriate multiplexing category. Since the multiplexing categories defined in this specification are independent of any informal semantic groupings of the SDP attributes, the categorizations assigned are normative.
Category: NORMAL
The attributes in the NORMAL category can be independently specified when multiplexed, and they retain their original semantics.
In the example given below, the direction and label attributes are independently specified for audio and video "m=" lines. These attributes are not impacted by multiplexing these media streams over a single transport-layer flow.

     v=0
     o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
     s=
     c=IN IP4 host.atlanta.example.com
     t=0 0
     m=audio 49172 RTP/AVP 99
     a=sendonly
     a=label:1
     a=rtpmap:99 iLBC/8000
     m=video 49172 RTP/AVP 31
     a=recvonly
     a=label:2
     a=rtpmap:31 H261/90000

Category: CAUTION
It is not advisable to multiplex with the attributes in the CAUTION category, since their usage under multiplexing might lead to incorrect behavior.
Example: Multiplexing media descriptions over a single Datagram Congestion Control Protocol (DCCP) transport [RFC5762] is not recommended, since DCCP is a connection-oriented protocol and therefore doesn't allow multiple connections on the same 5-tuple.

     v=0
     o=bob 2890844527 2890844527 IN IP4 client.biloxi.example.com
     s=
     c=IN IP4 client.biloxi.example.com
     t=0 0
     m=video 5004 DCCP/RTP/AVP 99
     a=rtpmap:99 h261/9000
     a=dccp-service-code:SC=x52545056
     a=setup:passive
     a=connection:new
     m=video 5004 DCCP/RTP/AVP 100
     a=rtpmap:100 h261/9000
     a=dccp-service-code:SC=x5254504f
     a=setup:passive
     a=connection:new

Category: IDENTICAL
The attributes and their associated values (if any) in the IDENTICAL category MUST be repeated across all the media descriptions under multiplexing.
Attributes such as rtcp-mux fall into this category. Since RTCP reporting is done per RTP session, RTCP multiplexing MUST be enabled for both the audio and video "m=" lines if they are transported over a single 5-tuple.

     v=0
     o=bob 2890844527 2890844527 IN IP4 client.biloxi.example.com
     s=
     c=IN IP4 client.biloxi.example.com
     t=0 0
     m=audio 34567 RTP/AVP 97
     a=rtcp-mux
     m=video 34567 RTP/AVP 31
     a=rtpmap:31 H261/90000
     a=rtcp-mux

Note: Even though IDENTICAL attributes must be repeated across all media descriptions under multiplexing, they might not always be explicitly encoded across all media descriptions. [RFC8843] defines rules for when attributes and their values are implicitly applied to media description.
Category: SUM
The attributes in the SUM category can be set as they are normally used, but software using them in the multiplexing scenario MUST apply the sum of all the attributes being multiplexed instead of trying to use them independently. This is typically used for bandwidth or other rate-limiting attributes to the underlying transport.
The software parsing the SDP sample below should use the aggregate Application Specific (AS) bandwidth value from the individual media descriptions to determine the AS value for the multiplexed session. Thus the calculated AS value would be 256+64 kilobits per second for the given example.

      v=0
      o=test 2890844526 2890842807 IN IP4 client.biloxi.example.com
      c=IN IP4 client.biloxi.example.com
      t=0 0
      m=audio 49170 RTP/AVP 0
      b=AS:64
      m=video 51372 RTP/AVP 31
      b=AS:256

Category: TRANSPORT
The attributes in the TRANSPORT category can be set normally for multiple items in a multiplexed group, but the software MUST pick the one that's associated with the "m=" line whose information is used for setting up the underlying transport.
In the example below, the "a=crypto" attribute is defined for both the audio and video "m=" lines. The video media line's a=crypto attribute is chosen since its mid value (bar) appears first in the a=group:BUNDLE line. This is due to the BUNDLE grouping semantic [RFC8843], which mandates that the values from the "m=" line corresponding to the mid appearing first on the a=group:BUNDLE line be considered for setting up the RTP transport.

     v=0
     o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
     s=
     c=IN IP4 host.atlanta.example.com
     t=0 0
     a=group:BUNDLE bar foo
     m=audio 49172 RTP/AVP 99
     a=mid:foo
     a=crypto:1 AES_CM_128_HMAC_SHA1_80
       inline:d0RmdmcmVCspeEc3QGZiNWpVLFJhQX1cfHAwJSoj|2^20|1:32
     a=rtpmap:99 iLBC/8000
     m=video 51374 RTP/AVP 31
     a=mid:bar
     a=crypto:1 AES_CM_128_HMAC_SHA1_80
       inline:EcGZiNWpFJhQXdspcl1ekcmVCNWpVLcfHAwJSoj|2^20|1:32
     a=rtpmap:96 H261/90000

Category: INHERIT
The attributes in the INHERIT category encapsulate other SDP attributes or parameters. These attributes inherit their multiplexing characteristics from the attributes or parameters they encapsulate. Such attributes are defined in [RFC3407], [RFC5939], and [RFC6871] as part of a generic framework for indicating and negotiating capabilities in the SDP related to transport, media, and media format.
The inheritance manifests itself when the encapsulated attribute or parameter is being leveraged. In the case of SDP Capability Negotiation [RFC5939], for example, this occurs when a capability (encapsulating attribute) is used as part of a configuration; the configuration inherits the multiplexing category of each of its constituent (encapsulated) attributes and parameters. The inherited attributes MUST be coherent in order to form a valid configuration from a multiplexing point of view (see Section 14 for further details).

       v=0
       o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
       s=
       c=IN IP4 host.atlanta.example.com
       t=0 0
       m=video 3456 RTP/AVP 100
       a=rtpmap:100 VP8/90000
       a=fmtp:100 max-fr=30;max-fs=8040
       a=sqn: 0
       a=cdsc: 1 video RTP/AVP 100
       a=cpar: a=rtcp-mux
       m=video 3456 RTP/AVP 101
       a=rtpmap:101 VP8/90000
       a=fmtp:100 max-fr=15;max-fs=1200
       a=cdsc: 2 video RTP/AVP 101
       a=cpar: a=rtcp-mux
In this example, the category IDENTICAL is inherited by the cpar-encapsulated "rtcp-mux" attribute.
Category: IDENTICAL-PER-PT
The attributes in the IDENTICAL-PER-PT category define the RTP payload configuration on the basis of the payload type, and they MUST have identical values across all the media descriptions for a given RTP payload type when repeated.
These payload types identify the same codec configuration as defined in Section 9.1 of [RFC8843] under this context.
In the SDP example below, Payload Types 96 and 97 are repeated across all the video "m=" lines, and all the payload-specific parameters (for example, rtpmap and fmtp) are identical. (Note: some line breaks are due to formatting only.)

     v=0
     o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
     s=
     c=IN IP4 host.atlanta.example.com
     t=0 0
     a=group:BUNDLE cam1 cam2
     m=video 96 97
     a=mid:cam1
     a=rtpmap:96 H264/90000
     a=fmtp:96 profile-level-id=42400d; max-fs=3600; max-fps=3000;
     max-mbps=108000; max-br=1000
     a=rtpmap:97 H264/90000
     a=fmtp:97 profile-level-id=42400a; max-fs=240; max-fps=3000;
     max-mbps=7200; max-br=200
     m=video  96 97
     a=mid:cam2
     a=rtpmap:96 H264/90000
     a=fmtp:96 profile-level-id=42400d; max-fs=3600; max-fps=3000;
     max-mbps=108000; max-br=1000
     a=rtpmap:97 H264/90000
     a=fmtp:97 profile-level-id=42400a; max-fs=240; max-fps=3000;
     max-mbps=7200; max-br=200
Category: SPECIAL
For the attributes in the SPECIAL category, the text in the specification defining the attribute MUST be consulted for further handling when multiplexed.
As an example, for the attribute "extmap" [RFC5285], the specification defining the extension needs to be consulted to understand the multiplexing implications.
Category: TBD
The attributes in the TBD category have not been analyzed under the proposed multiplexing framework and SHOULD NOT be multiplexed.
Analysis of Existing Attributes
This section analyzes attributes listed in [IANA], grouped under the IETF document that defines them.
The "Level" column indicates whether the attribute is currently specified as:
- S -- Session level
- M -- Media level
- B -- Both (Implies either a session level or a media level attribute)
- SR -- Source-level (for a single SSRC) [RFC5576]
The "Mux Category" column identifies the multiplexing category assigned to each attribute, and the "Notes" column captures additional informative details regarding the assigned category, wherever necessary.
RFC 4566: SDP
[RFC4566] defines SDP that is intended for describing multimedia sessions for the purposes of session announcement, session invitation, and other forms of multimedia session initiation.
RFC 4566 Attribute Analysis
Name | Notes | Level | Mux Category
sendrecv | Not impacted | B | NORMAL
sendonly | Not impacted | B | NORMAL
recvonly | Not impacted | B | NORMAL
inactive | Not impacted | B | NORMAL
cat | Not impacted | S | NORMAL
ptime | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
maxptime | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
orient | Not impacted | M | NORMAL
framerate | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
quality | Not impacted | M | NORMAL
rtpmap | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
fmtp | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
keywds | Not impacted | S | NORMAL
type | Not impacted | S | NORMAL
type:broadcast | Not impacted | S | NORMAL
type:H332 | Not impacted | S | NORMAL
type:meeting | Not impacted | S | NORMAL
type:moderated | Not impacted | S | NORMAL
type:test | Not impacted | S | NORMAL
tool | Not impacted | S | NORMAL
charset | Not impacted | S | NORMAL
sdplang | Not impacted | B | NORMAL
lang | Not impacted | B | NORMAL
RFC 4585: RTP/AVPF
[RFC4585] defines an extension to the Audio-visual Profile (AVP) that enables receivers to provide, statistically, more immediate feedback to the senders and thus allows for short-term adaptation and efficient feedback-based repair mechanisms to be implemented.
RFC 4585 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-fb | Since RTCP feedback attributes are scoped by payload type (PT), their values MUST be identical for a given PT across the multiplexed "m=" lines. | M | IDENTICAL-PER-PT
RFC 5761: Multiplexing RTP and RTCP
[RFC5761] discusses issues that arise when multiplexing RTP data packets and RTP Control Protocol (RTCP) packets on a single UDP port. It describes when such multiplexing is and is not appropriate, and it explains how the SDP can be used to signal multiplexed sessions.
RFC 5761 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-mux | RTP and RTCP multiplexing affects the entire RTP session. | M | IDENTICAL
RFC 3312: Integration of Resource Management and SIP
[RFC3312] defines a generic framework for preconditions, which are extensible through IANA registration. This document also discusses how network quality of service can be made a precondition for establishment of sessions initiated by the Session Initiation Protocol (SIP). These preconditions require that the participant reserve network resources before continuing with the session.
RFC 3312 Attribute Analysis
Name | Notes | Level | Mux Category
des | Refer to notes below | M | CAUTION
conf | Refer to notes below | M | CAUTION
curr | Refer to notes below | M | CAUTION
NOTE: A mismatched set of preconditions across media descriptions results in session establishment failures due to inability to meet the requested resource reservations.
RFC 4574: SDP "label" Attribute
[RFC4574] defines a new SDP media-level attribute: "label". The "label" attribute carries a pointer to a media stream in the context of an arbitrary network application that uses SDP. The sender of the SDP document can attach the "label" attribute to a particular media stream or streams. The application can then use the provided pointer to refer to each particular media stream in its context.
RFC 4574 Attribute Analysis
Name | Notes | Level | Mux Category
label | Not impacted | M | NORMAL
RFC 5432: QoS Mechanism Selection in SDP
[RFC5432] defines procedures for negotiating QoS mechanisms using the SDP offer/answer model.
RFC 5432 Attribute Analysis
Name | Notes | Level | Mux Category
qos-mech-send | Refer to Section 10. | B | TRANSPORT
qos-mech-recv | Refer to Section 10. | B | TRANSPORT
RFC 4568: SDP Security Descriptions
[RFC4568] defines an SDP cryptographic attribute for unicast media streams. The attribute describes a cryptographic key and other parameters that serve to configure security for a unicast media stream in either a single message or a roundtrip exchange.
RFC 4568 Attribute Analysis
Name | Notes | Level | Mux Category
crypto | crypto attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
RFC 5762: RTP over DCCP
RTP is a widely used transport for real-time multimedia on IP networks. DCCP is a transport protocol that provides desirable services for real-time applications. [RFC5762] specifies a mapping of RTP onto DCCP, along with associated signaling, such that real-time applications can make use of the services provided by DCCP.
RFC 5762 Attribute Analysis
Name | Notes | Current | Mux Category
dccp-service-code | If RFC 6773 is not being used in addition to RFC5762, the port in the "m=" line is a DCCP port. Being a connection-oriented protocol, DCCP does not allow multiple connections on the same 5-tuple. | M | CAUTION
NOTE: If RFC 6773 is being used in addition to RFC 5762, and the DCCP-in-UDP layer has additional demultiplexing, then it may be possible to use different DCCP service codes for each DCCP flow, given each uses a different DCCP port. However, doing so might conflict with the media type of the "m=" line. None of this is standardized yet, and it wouldn't work as explained. Hence performing multiplexing is not recommended even in this alternate scenario.
RFC 6773: DCCP-UDP Encapsulation
[RFC6773] specifies an alternative encapsulation of DCCP, referred to as DCCP-UDP. This encapsulation allows DCCP to be carried through the current generation of Network Address Translation (NAT) middleboxes without modification of those middleboxes.
RFC 6773 Attribute Analysis
Name | Notes | Level | Mux Category
dccp-port | Multiplexing is not recommended due to potential conflict between the port used for DCCP encapsulation/decapsulation and the RTP. | M | CAUTION
NOTE: RFC 6773 allows DCCP-UDP encapsulation, with the UDP port being the port of the DCCP encapsulation/decapsulation service. This encapsulation allows arbitrary DCCP packets to be encapsulated, and the DCCP port chosen can conflict with the port chosen for the RTP traffic.
Multiplexing several DCCP-in-UDP encapsulations on the same UDP port with no RTP traffic on the same port implies collapsing several DCCP port spaces together. Whether or not this works depends on the nature of DCCP encapsulation and ports choices; it is thus very application dependent.
RFC 5506: Reduced-Size RTCP in RTP Profile
[RFC5506] discusses benefits and issues that arise when allowing RTCP packets to be transmitted with reduced size.
RFC 5506 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-rsize | Reduced-size RTCP affects the entire RTP session. | M | IDENTICAL
RFC 6787: Media Resource Control Protocol Version 2
The Media Resource Control Protocol Version 2 (MRCPv2) allows client hosts to control media service resources such as speech synthesizers, recognizers, verifiers, and identifiers residing in servers on the network. MRCPv2 is not a "stand-alone" protocol; it relies on other protocols, such as the SIP, to coordinate MRCPv2 clients and servers and manage session between them, and SDP to describe, discover, and exchange capabilities. It also depends on SIP and SDP to establish the media sessions and associated parameters between the media source or sink and the media server. Once this is done, the MRCPv2 exchange operates over the control session established above, allowing the client to control the media-processing resources on the speech resource server. [RFC6787] defines attributes for this purpose.
RFC 6787 Attribute Analysis
Name | Notes | Level | Mux Category
resource | Not impacted | M | NORMAL
channel | Not impacted | M | NORMAL
cmid | Not impacted | M | NORMAL
RFC 8445: ICE
[RFC8445] describes a protocol for NAT traversal for UDP-based multimedia sessions established with the offer/answer model. ICE makes use of the Session Traversal Utilities for NAT (STUN) protocol and its extension, Traversal Using Relay NAT (TURN). ICE can be used by any protocol utilizing the offer/answer model, such as the SIP.
RFC 8445 Attribute Analysis
Name | Notes | Level | Mux Category
ice-lite | Not impacted | S | NORMAL
ice-options | Not impacted | S | NORMAL
ice-mismatch | Not impacted | S | NORMAL
ice-pwd | ice-pwd MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
ice-ufrag | ice-ufrag MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
candidate | ice candidate MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
remote-candidates | ice remote candidate MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
ice2 | Not impacted | S | NORMAL
RFC 5285: RTP Header Extensions
[RFC5285] provides a general mechanism for using the header-extension feature of RTP. (Note: [RFC5285] has been obsoleted by [RFC8285].) It provides the option to use a small number of small extensions in each RTP packet, where the universe of possible extensions is large and registration is decentralized. The actual extensions in use in a session are signaled in the setup information for that session.
RFC 5285 Attribute Analysis
Name | Notes | Level | Mux Category
extmap | Refer to the document defining the specific RTP extension. | B | SPECIAL
RFC 3605: RTCP Attribute in SDP
Originally, SDP assumed that RTP and RTCP were carried on consecutive ports. However, this is not always true when NATs are involved. [RFC3605] specifies an early mechanism for indicating the RTCP port.
RFC 3605 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp | RTCP port MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
RFC 5576: Source-Specific SDP Attributes
[RFC5576] defines a mechanism for describing RTP media sources -- which are identified by their synchronization source (SSRC) identifiers -- in SDP, to associate attributes with these sources and express relationships among sources. It also defines several source-level attributes that can be used to describe properties of media sources.
RFC 5576 Attribute Analysis
Name | Notes | Level | Mux Category
ssrc | Refer to notes below. | M | NORMAL
ssrc-group | Refer to Section 9 for specific analysis of the grouping semantics. | M | NORMAL
cname | Not impacted | SR | NORMAL
previous-ssrc | Refer to notes below | SR | NORMAL
fmtp | The attribute value MUST be the same for a given codec configuration. | SR | IDENTICAL-PER-PT
NOTE: If SSRCs are repeated across "m=" lines being multiplexed, they MUST all represent the same underlying RTP Source.
RFC 7273: RTP Clock Source Signaling
[RFC7273] specifies SDP signaling that identifies timestamp reference clock sources and SDP signaling that identifies the media clock sources in a multimedia session.
RFC 7273 Attribute Analysis
Name | Notes | Level | Mux Category
ts-refclk | Not impacted | B | NORMAL
mediaclk | Not impacted | B | NORMAL
ts-refclk:ntp | Not impacted | B | NORMAL
ts-refclk:ptp | Not impacted | B | NORMAL
ts-refclk:gps | Not impacted | B | NORMAL
ts-refclk:gal | Not impacted | B | NORMAL
ts-refclk:glonass | Not impacted | B | NORMAL
ts-refclk:local | Not impacted | B | NORMAL
ts-refclk:private | Not impacted | B | NORMAL
mediaclk:sender | Not impacted | B | NORMAL
mediaclk:direct | Not impacted | B | NORMAL
mediaclk:IEEE1722 | Not impacted | B | NORMAL
RFC 6236: Image Attributes in SDP
[RFC6236] proposes a new generic session setup attribute to make it possible to negotiate different image attributes, such as image size. A possible use case is to make it possible for a low-end handheld terminal to display video without the need to rescale the image, something that may consume large amounts of memory and processing power. The document also helps to maintain an optimal bitrate for video as only the image size that is desired by the receiver is transmitted.
RFC 6236 Attribute Analysis
Name | Notes | Level | Mux Category
imageattr | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 7197: Duplication Delay Attribute in SDP
[RFC7197] defines an attribute to indicate the presence of temporally redundant media streams and the duplication delay in SDP.
RFC 7197 Attribute Analysis
Name | Notes | Level | Mux Category
duplication-delay | Not impacted | B | NORMAL
RFC 7266: RTCP XR Blocks for MOS Metric Reporting
[RFC7266] defines an RTCP Extended Report (XR) Block that includes two new segment types and associated SDP parameters that allow the reporting of mean opinion score (MOS) metrics for use in a range of RTP applications.
RFC 7266 Attribute Analysis
Name | Notes | Level | Mux Category
calgextmap | Not impacted | B | NORMAL
RFC 6285: Rapid Acquisition of Multicast RTP Sessions
[RFC6285] describes a method of using the existing RTP and RTCP machinery that reduces the acquisition delay. In this method, an auxiliary unicast RTP session carrying the reference information to the receiver precedes or accompanies the multicast stream. This unicast RTP flow can be transmitted at a faster-than-natural bitrate to further accelerate the acquisition. The motivating use case for this capability is multicast applications that carry real-time compressed audio and video.
RFC 6285 Attribute Analysis
Name | Notes | Level | Mux Category
rams-updates | Not recommended | M | CAUTION
RFC 6230: Media Control Channel Framework
[RFC6230] describes a framework and protocol for application deployment where the application programming logic and media processing are distributed. This implies that application programming logic can seamlessly gain access to appropriate resources that are not co-located on the same physical network entity. The framework uses SIP to establish an application-level control mechanism between application servers and associated external servers such as media servers.
RFC 6230 Attribute Analysis
Name | Notes | Level | Mux Category
cfw-id | Not impacted | M | NORMAL
RFC 6364: SDP Elements for FEC Framework
[RFC6364] specifies the use of SDP to describe the parameters required to signal the Forward Error Correction (FEC) Framework Configuration Information between the sender(s) and receiver(s). This document also provides examples that show the semantics for grouping multiple source and repair flows together for the applications that simultaneously use multiple instances of the FEC Framework.
RFC 6364 Attribute Analysis
Name | Notes | Level | Mux Category
fec-source-flow | Refer to the document defining specific FEC scheme. | M | SPECIAL
fec-repair-flow | Refer to the document defining specific FEC scheme. | M | SPECIAL
repair-window | Refer to the document defining specific FEC scheme. | M | SPECIAL
RFC 4796: "content" Attribute
[RFC4796] defines a new SDP media-level attribute, "content". The "content" attribute defines the content of the media stream to a more detailed level than the media description line. The sender of an SDP session description can attach the "content" attribute to one or more media streams. The receiving application can then treat each media stream differently (e.g., show it on a big or small screen) based on its content.
RFC 4796 Attribute Analysis
Name | Notes | Level | Mux Category
content | Not impacted | M | NORMAL
RFC 3407: SDP Simple Capability Declaration
[RFC3407] defines a set of SDP attributes that enables SDP to provide a minimal and backwards-compatible capability declaration mechanism.
RFC 3407 Attribute Analysis
Name | Notes | Level | Mux Category
sqn | Not impacted | B | NORMAL
cdsc | Not impacted | B | NORMAL
cpar | Refer to Section 14 | B | INHERIT
cparmin | Refer to notes below | B | SPECIAL
cparmax | Refer to notes below | B | SPECIAL
NOTE: The attributes "a=cparmin" and "a=cparmax" define minimum and maximum numerical values associated with the attributes described in "a=cpar".
Since the cpar attribute can either define a "b=" attribute or any "a=" attribute, the multiplexing category depends on the actual attribute being encapsulated and the implications of the numerical values assigned. Hence it is recommended to consult the specification defining attributes "cparmin" and "cparmax" to further analyze their behavior under multiplexing.
RFC 6284: Port Mapping between Unicast and Multicast RTP Sessions
[RFC6284] presents a port-mapping solution that allows RTP receivers to choose their own ports for an auxiliary unicast session in RTP applications using both unicast and multicast services. The solution provides protection against denial-of-service or packet amplification attacks that could be used to cause one or more RTP packets to be sent to a victim client.
RFC 6284 Attribute Analysis
Name | Notes | Level | Mux Category
portmapping-req | Not recommended if port mapping is required by the application | M | CAUTION
RFC 6714: MSRP-CEMA
[RFC6714] defines a Message Session Relay Protocol (MSRP) extension, Connection Establishment for Media Anchoring (CEMA). Support of this extension is optional. The extension allows middleboxes to anchor the MSRP connection without the need for middleboxes to modify the MSRP messages; thus, it also enables secure end-to-end MSRP communication in networks where such middleboxes are deployed. This document also defines an SDP attribute, "msrp-cema", that MSRP endpoints use to indicate support of the CEMA extension.
RFC 6714 Attribute Analysis
Name | Notes | Level | Mux Category
msrp-cema | Refer to notes below | M | TBD
NOTE: As per Section 9 of [RFC8843], there exists no publicly available specification that defines procedures for multiplexing/demultiplexing MSRP flows over a single 5-tuple. Once such a specification is available, the assignments of multiplexing categories for the attributes in this section could be revisited.
RFC 4583: SDP Format for BFCP Streams
[RFC4583] specifies how to describe Binary Floor Control Protocol (BFCP) streams in SDP descriptions. User agents using the offer/answer model to establish BFCP streams use this format in their offers and answers.
RFC 4583 Attribute Analysis
Name | Notes | Level | Mux Category
floorctrl | Refer to notes below | M | TBD
confid | Refer to notes below | M | TBD
userid | Refer to notes below | M | TBD
floorid | Refer to notes below | M | TBD
NOTE: [RFC4583] has been obsoleted by [RFC8856], which redefines the SDP attributes listed in this section, including the "Mux Category" values. However, [RFC8856] does not change the "Mux Category" values of the attributes.
NOTE: As per Section 9 of [RFC8843], there exists no publicly available specification that defines procedures for multiplexing/demultiplexing BFCP streams over a single 5-tuple. Once such a specification is available, the assignments of multiplexing categories for the attributes in this section could be revisited.
RFC 5547: SDP Offer/Answer for File Transfer
[RFC5547] provides a mechanism to negotiate the transfer of one or more files between two endpoints by using the SDP offer/answer model specified in [RFC3264].
RFC 5547 Attribute Analysis
Name | Notes | Level | Mux Category
file-selector | Refer to notes below | M | TBD
file-transfer-id | Refer to notes below | M | TBD
file-disposition | Refer to notes below | M | TBD
file-date | Refer to notes below | M | TBD
file-icon | Refer to notes below | M | TBD
file-range | Refer to notes below | M | TBD
NOTE: As per Section 9 of [RFC8843], there exists no publicly available specification that defines procedures for multiplexing/demultiplexing MSRP flows over a single 5-tuple. Once such a specification is available, the assignments of multiplexing categories for attributes in this section could be revisited.
RFC 6849: SDP and RTP Media Loopback Extension
[RFC6849] adds new SDP media types and attributes that enable establishment of media sessions where the media is looped back to the transmitter. Such media sessions will serve as monitoring and troubleshooting tools by providing the means for measurement of more advanced Voice over IP (VoIP), real-time text, and Video over IP performance metrics.
RFC 6849 Analysis
Name | Notes | Level | Mux Category
loopback rtp-pkt-loopback | The attribute value MUST be same for a given codec configuration. | M | IDENTICAL-PER-PT
loopback rtp-media-loopback | The attribute value MUST be same for a given codec configuration. | M | IDENTICAL-PER-PT
loopback-source | Not impacted | M | NORMAL
loopback-mirror | Not impacted | M | NORMAL
RFC 5760: RTCP with Unicast Feedback
[RFC5760] specifies an extension to RTCP to use unicast feedback to a multicast sender. The proposed extension is useful for single-source multicast sessions such as source-specific multicast (SSM) communication where the traditional model of many-to-many group communication is either not available or not desired.
RFC 5760 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-unicast | The attribute MUST be reported across all multiplexed "m=" lines. | M | IDENTICAL
RFC 3611: RTCP XR
[RFC3611] defines the Extended Report (XR) packet type for RTCP and defines how the use of XR packets can be signaled by an application if it employs the Session Description Protocol (SDP).
RFC 3611 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-xr | Not impacted | B | NORMAL
RFC 5939: SDP Capability Negotiation
[RFC5939] defines a general SDP Capability Negotiation framework. It also specifies how to provide attributes and transport protocols as capabilities and negotiate them using the framework. Extensions for other types of capabilities (e.g., media types and media formats) may be provided in other documents.
RFC 5939 Attribute Analysis
Name | Notes | Level | Mux Category
pcfg | Refer to Section 14 | M | SPECIAL
acfg | Refer to Section 14 | M | SPECIAL
csup | Not impacted | B | NORMAL
creq | Not impacted | B | NORMAL
acap | Refer to Section 14 | B | INHERIT
tcap | Refer to Section 14 | B | INHERIT
cap-v0 | Not impacted | B | NORMAL
RFC 6871: SDP Media Capabilities Negotiation
SDP capability negotiation provides a general framework for indicating and negotiating capabilities in SDP. The base framework only defines capabilities for negotiating transport protocols and attributes. [RFC6871] extends the framework by defining media capabilities that can be used to negotiate media types and their associated parameters.
RFC 6871 Attribute Analysis
Name | Notes | Level | Mux Category
rmcap | Refer to Section 14 | B | IDENTICAL-PER-PT
omcap | Not impacted | B | NORMAL
mfcap | Refer to Section 14 | B | IDENTICAL-PER-PT
mscap | Refer to Section 14 | B | INHERIT
lcfg | Refer to Section 14 | B | SPECIAL
sescap | Refer to notes below | S | CAUTION
med-v0 | Not impacted | S | NORMAL
NOTE: The "sescap" attribute is not recommended for use with multiplexing. The reason is that it requires the use of unique configuration numbers across the entire SDP (per [RFC6871]) as opposed to within a media description only (per [RFC5939]). As described in Section 14, the use of identical configuration numbers between multiplexed (bundled) media descriptions is the default way of indicating compatible configurations in a bundle.
RFC 7006: Miscellaneous Capabilities Negotiation in SDP
[RFC7006] extends the SDP Capability Negotiation framework to allow endpoints to negotiate three additional SDP capabilities. In particular, this memo provides a mechanism to negotiate bandwidth ("b=" line), connection data ("c=" line), and session or media titles ("i=" line for each session or media).
RFC 7006 Attribute Analysis
Name | Notes | Level | Mux Category
bcap | Inherit the category SUM as applicable to the "b=" attribute | B | INHERIT
bcap-v0 | Not impacted | B | NORMAL
ccap | The connection address type MUST be identical across all the multiplexed "m=" lines. | B | IDENTICAL
ccap-v0 | Not impacted | B | NORMAL
icap | Not impacted | B | NORMAL
icap-v0 | Not impacted | B | NORMAL
RFC 4567: Key Management Extensions for SDP and RTSP
[RFC4567] defines general extensions for SDP and Real Time Streaming Protocol (RTSP) to carry messages, as specified by a key management protocol, in order to secure the media. These extensions are presented as a framework to be used by one or more key management protocols. As such, their use is meaningful only when complemented by an appropriate key management protocol.
RFC 4567 Attribute Analysis
Name | Notes | Level | Mux Category
key-mgmt | Key management protocol MUST be identical across all the "m=" lines. | B | IDENTICAL
mikey | Key management protocol MUST be identical across all the "m=" lines. | B | IDENTICAL
RFC 4572: Comedia over TLS in SDP
[RFC4572] specifies how to establish secure connection-oriented media transport sessions over the Transport Layer Security (TLS) protocol using SDP. (Note: [RFC4572] has been obsoleted by [RFC8122].) It defines a new SDP protocol identifier, "TCP/TLS". It also defines the syntax and semantics for an SDP "fingerprint" attribute that identifies the certificate that will be presented for the TLS session. This mechanism allows media transport over TLS connections to be established securely, so long as the integrity of session descriptions is assured.
RFC 4572 Attribute Analysis
Name | Notes | Level | Mux Category
fingerprint | fingerprint value MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
RFC 4570: SDP Source Filters
[RFC4570] describes how to adapt SDP to express one or more source addresses as a source filter for one or more destination "connection" addresses. It defines the syntax and semantics for an SDP "source-filter" attribute that may reference either IPv4 or IPv6 address(es) as either an inclusive or exclusive source list for either multicast or unicast destinations. In particular, an inclusive source filter can be used to specify a source-specific multicast (SSM) session.
RFC 4570 Attribute Analysis
Name | Notes | Level | Mux Category
source-filter | The attribute MUST be repeated across all multiplexed "m=" lines. | B | IDENTICAL
RFC 6128: RTCP Port for Multicast Sessions
SDP has an attribute that allows RTP applications to specify an address and a port associated with the RTCP traffic. In RTP-based source-specific multicast (SSM) sessions, the same attribute is used to designate the address and the RTCP port of the Feedback Target in the SDP description. However, the RTCP port associated with the SSM session itself cannot be specified by the same attribute to avoid ambiguity and thus is required to be derived from the "m=" line of the media description. Deriving the RTCP port from the "m=" line imposes an unnecessary restriction. [RFC6128] removes this restriction by introducing a new SDP attribute.
RFC 6128 Attribute Analysis
Name | Notes | Level | Mux Category
multicast-rtcp | Multicast RTCP port MUST be identical across all the "m=" lines. | B | IDENTICAL
RFC 6189: ZRTP
[RFC6189] defines ZRTP, a protocol for media path Diffie-Hellman exchange to agree on a session key and parameters for establishing unicast SRTP sessions for VoIP applications.
RFC 6189 Attribute Analysis
Name | Notes | Level | Mux Category
zrtp-hash | The zrtp-hash attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
RFC 4145: Connection-Oriented Media
[RFC4145] describes how to express media transport over TCP using SDP. It defines the SDP "TCP" protocol identifier, the SDP "setup" attribute, which describes the connection setup procedure, and the SDP "connection" attribute, which handles connection re-establishment.
RFC 4145 Attribute Analysis
Name | Notes | Level | Mux Category
setup | The setup attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
connection | The connection attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
RFC 6947: The SDP "altc" Attribute
[RFC6947] proposes a mechanism that allows the same SDP offer to carry multiple IP addresses of different address families (e.g., IPv4 and IPv6). The proposed "altc" attribute solves the backward-compatibility problem that plagued Alternative Network Address Types (ANAT) due to their syntax.
RFC 6947 Attribute Analysis
Name | Notes | Level | Mux Category
altc | The IP address and port MUST be the ones that correspond to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
RFC 7195: SDP Extension for Circuit-Switched Bearers in PSTN
[RFC7195] describes use cases, requirements, and protocol extensions for using the SDP offer/answer model for establishing audio and video media streams over circuit-switched bearers in the Public Switched Telephone Network (PSTN).
RFC 7195 Attribute Analysis
Name | Notes | Level | Mux Category
cs-correlation:callerid | Refer to notes below | M | TBD
cs-correlation:uuie | Refer to notes below | M | TBD
cs-correlation:dtmf | Refer to notes below | M | TBD
cs-correlation:external | Refer to notes below | M | TBD
NOTE: [RFC7195] defines SDP attributes for establishing audio and video media streams over circuit-switched bearers by defining a new nettype value, "PSTN". However, Section 7.2 of [RFC8843] requires the "c=" line nettype value to be "IN". If there exists in future a specification that defines procedures to multiplex media streams over nettype "PSTN", the multiplexing categories for attributes in this section could be revisited.
RFC 7272: IDMS Using the RTP Control Protocol (RTCP)
[RFC7272] defines a new RTCP packet type and an RTCP Extended Report (XR) Block Type to be used for achieving Inter-Destination Media Synchronization (IDMS).
RFC 7272 Attribute Analysis
Name | Notes | Level | Mux Category
rtcp-idms | Not impacted | M | NORMAL
RFC 5159: Open Mobile Alliance (OMA) Broadcast (BCAST) SDP Attributes
[RFC5159] provides descriptions of SDP attributes used by the Open Mobile Alliance's "Service and Content Protection for Mobile Broadcast Services" specification.
RFC 5159 Attribute Analysis
Name | Notes | Level | Mux Category
bcastversion | Not impacted | S | NORMAL
stkmstream | Not impacted | B | NORMAL
SRTPAuthentication | Needs further analysis | M | TBD
SRTPROCTxRate | Needs further analysis | M | TBD
RFC 6193: Media Description for IKE in SDP
[RFC6193] specifies how to establish a media session that represents a virtual private network using the Session Initiation Protocol for the purpose of on-demand media/application sharing between peers. It extends the protocol identifier of SDP so that it can negotiate use of the Internet Key Exchange Protocol (IKE) for media sessions in the SDP offer/answer model.
RFC 6193 Attribute Analysis
Name | Notes | Level | Mux Category
ike-setup | Unlikely to use IKE in the context of multiplexing | B | CAUTION
psk-fingerprint | Unlikely to use IKE in the context of multiplexing | B | CAUTION
ike-esp | Unlikely to use IKE in the context of multiplexing | B | CAUTION
ike-esp-udpencap | Unlikely to use IKE in the context of multiplexing | B | CAUTION
RFC 2326: Real Time Streaming Protocol
The Real Time Streaming Protocol, or RTSP, is an application-level protocol for control over the delivery of data with real-time properties. RTSP provides an extensible framework to enable controlled, on-demand delivery of real-time data, such as audio and video.
RFC 2326 Attribute Analysis
Name | Notes | Level | Mux Category
etag | RTSP is not supported for RTP stream multiplexing. | B | CAUTION
range | RTSP is not supported for RTP stream multiplexing. | B | CAUTION
control | RTSP is not supported for RTP stream multiplexing. | B | CAUTION
mtag | RTSP is not supported for RTP stream multiplexing. | B | CAUTION
NOTE: [RFC2326] defines SDP attributes that are applicable in the declarative usage of SDP alone. For the purposes of this document, only the offer/answer usage of SDP is considered to be mandated by [RFC8843].
RFC 6064: SDP and RTSP Extensions for 3GPP
The Packet-switched Streaming Service (PSS) and the Multimedia Broadcast/Multicast Service (MBMS) defined by 3GPP use SDP and RTSP with some extensions. [RFC6064] provides information about these extensions and registers the RTSP and SDP extensions with IANA.
RFC 6064 Attribute Analysis
Name | Notes | Level | Mux Category
X-predecbufsize | Refer to notes below | M | CAUTION
X-initpredecbufperiod | Refer to notes below | M | CAUTION
X-initpostdecbufperiod | Refer to notes below | M | CAUTION
X-decbyterate | Refer to notes below | M | CAUTION
3gpp-videopostdecbufsize | Refer to notes below | M | CAUTION
framesize | Refer to notes below | M | CAUTION
3GPP-Integrity-Key | Refer to notes below | S | CAUTION
3GPP-SDP-Auth | Refer to notes below | S | CAUTION
3GPP-SRTP-Config | Refer to notes below | M | CAUTION
alt | Refer to notes below | M | CAUTION
alt-default-id | Refer to notes below | M | CAUTION
alt-group | Refer to notes below | S | CAUTION
3GPP-Adaptation-Support | Refer to notes below | M | CAUTION
3GPP-Asset-Information | Refer to notes below | B | CAUTION
mbms-mode | Refer to notes below | B | CAUTION
mbms-flowid | Refer to notes below | M | CAUTION
mbms-repair | Refer to notes below | B | CAUTION
3GPP-QoE-Metrics | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Corruption duration | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Rebuffering duration | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Initial buffering duration | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Successive loss of RTP packets | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Frame rate deviation | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Jitter duration | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Content Switch Time | Refer to notes below | B | CAUTION
3GPP-QoE-Metrics:Average Codec Bitrate | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Codec Information | Refer to notes below | M | CAUTION
3GPP-QoE-Metrics:Buffer Status | Refer to notes below | M | CAUTION
NOTE: [RFC6064] defines SDP attributes that are applicable in the declarative usage of SDP alone. For the purposes of this document, only the offer/answer usage of SDP is considered to be mandated by [RFC8843].
RFC 3108: ATM SDP
[RFC3108] describes conventions for using SDP described for controlling ATM bearer connections and any associated ATM Adaptation Layer (AAL).
RFC 3108 Attribute Analysis
Name | Notes | Level | Mux Category
aalType | Refer to notes below | B | CAUTION
eecid | Refer to notes below | B | CAUTION
capability | Refer to notes below | B | CAUTION
qosClass | Refer to notes below | B | CAUTION
bcob | Refer to notes below | B | CAUTION
stc | Refer to notes below | B | CAUTION
upcc | Refer to notes below | B | CAUTION
atmQOSparms | Refer to notes below | B | CAUTION
atmTrfcDesc | Refer to notes below | B | CAUTION
abrParms | Refer to notes below | B | CAUTION
abrSetup | Refer to notes below | B | CAUTION
bearerType | Refer to notes below | B | CAUTION
lij | Refer to notes below | B | CAUTION
anycast | Refer to notes below | B | CAUTION
cache | Refer to notes below | B | CAUTION
bearerSigIE | Refer to notes below | B | CAUTION
aalApp | Refer to notes below | B | CAUTION
cbrRate | Refer to notes below | B | CAUTION
sbc | Refer to notes below | B | CAUTION
clkrec | Refer to notes below | B | CAUTION
fec | Refer to notes below | B | CAUTION
prtfl | Refer to notes below | B | CAUTION
structure | Refer to notes below | B | CAUTION
cpsSDUsize | Refer to notes below | B | CAUTION
aal2CPS | Refer to notes below | B | CAUTION
aal2CPSSDUrate | Refer to notes below | B | CAUTION
aal2sscs3661unassured | Refer to notes below | B | CAUTION
aal2sscs3661assured | Refer to notes below | B | CAUTION
aal2sscs3662 | Refer to notes below | B | CAUTION
aal5sscop | Refer to notes below | B | CAUTION
atmmap | Refer to notes below | B | CAUTION
silenceSupp | Refer to notes below | B | CAUTION
ecan | Refer to notes below | B | CAUTION
gc | Refer to notes below | B | CAUTION
profileDesc | Refer to notes below | B | CAUTION
vsel | Refer to notes below | B | CAUTION
dsel | Refer to notes below | B | CAUTION
fsel | Refer to notes below | B | CAUTION
onewaySel | Refer to notes below | B | CAUTION
codecconfig | Refer to notes below | B | CAUTION
isup_usi | Refer to notes below | B | CAUTION
uiLayer1_Prot | Refer to notes below | B | CAUTION
chain | Refer to notes below | B | CAUTION
NOTE: RFC 3108 describes conventions for using SDP for characterizing ATM bearer connections using an AAL1, AAL2, or AAL5 adaptation layer. For AAL1, AAL2, and AAL5, bearer connections can be used to transport single media streams. In addition, for AAL1 and AAL2, multiple media streams can be multiplexed into a bearer connection. For all adaptation types (AAL1, AAL2, and AAL5), bearer connections can be bundled into a single media group. In all cases addressed by RFC 3108, a real-time media stream (voice, video, voiceband data, pseudowire, and others) or a multiplex of media streams is mapped directly into an ATM connection. RFC 3108 does not address cases where ATM serves as a low-level transport pipe for IP packets that can, in turn, carry one or more real-time (e.g., VoIP) media sessions with a life cycle different from that of the underlying ATM transport.
3GPP TS 183.063
[TISPAN] describes Telecommunications and Internet converged Services and Protocols for Advanced Networking (TISPAN);
3GPP TS 183.063 Attribute Analysis
Name | Notes | Level | Mux Category
PSCid | Not impacted | S | NORMAL
bc_service | Not impacted | S | NORMAL
bc_program | Not impacted | S | NORMAL
bc_service_package | Not impacted | S | NORMAL
3GPP TS 24.182
[IMS-CAT] specifies an IP multimedia subsystem for customized alerting tones.
3GPP TS 24.182 Attribute Analysis
Name | Notes | Level | Mux Category
g.3gpp.cat | Usage defined for the IP multimedia subsystem | M | NORMAL
3GPP TS 24.183
[IMS-CRS] specifies an IP multimedia subsystem for customized ringing signal.
3GPP TS 24.183 Attribute Analysis
Name | Notes | Level | Mux Category
g.3gpp.crs | Usage defined for the IP multimedia subsystem | M | NORMAL
3GPP TS 24.229
[IP-CALL] specifies an IP multimedia call control protocol based on Session Initial protocol and Session Description Protocol.
3GPP TS 24.229 Attribute Analysis
Name | Notes | Level | Mux Category
secondary-realm | secondary-realm MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
visited-realm | visited-realm MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | M | TRANSPORT
omr-m-cksum | Not impacted | M | NORMAL
omr-s-cksum | Not impacted | M | NORMAL
omr-m-att | Not impacted | M | NORMAL
omr-s-att | Not impacted | M | NORMAL
omr-m-bw | Not impacted | M | NORMAL
omr-s-bw | Not impacted | M | NORMAL
omr-codecs | Not impacted | M | NORMAL
ITU T.38
[T.38] defines procedures for real-time Group 3 facsimile communications over IP networks.
ITU T.38 Attribute Analysis
Name | Notes | Level | Mux Category
T38FaxVersion | Refer to notes below | M | TBD
T38MaxBitRate | Refer to notes below | M | TBD
T38FaxFillBitRemoval | Refer to notes below | M | TBD
T38FaxTranscodingMMR | Refer to notes below | M | TBD
T38FaxTranscodingJBIG | Refer to notes below | M | TBD
T38FaxRateManagement | Refer to notes below | M | TBD
T38FaxMaxBuffer | Refer to notes below | M | TBD
T38FaxMaxDatagram | Refer to notes below | M | TBD
T38FaxUdpEC | Refer to notes below | M | TBD
T38FaxMaxIFP | Refer to notes below | M | TBD
T38FaxUdpECDepth | Refer to notes below | M | TBD
T38FaxUdpFECMaxSpan | Refer to notes below | M | TBD
T38ModemType | Refer to notes below | M | TBD
T38VendorInfo | Refer to notes below | M | TBD
NOTE: As per Section 9 of [RFC8843], there exists no publicly available specification that defines procedures for multiplexing/demultiplexing fax protocol flows over a single 5-tuple. Once such a specification is available, the multiplexing category assignments for the attributes in this section could be revisited.
ITU-T Q.1970
[Q.1970] defines Bearer Independent Call Control (BICC) IP bearer control protocol.
ITU-T Q.1970 Attribute Analysis
Name | Notes | Level | Mux Category
ipbcp | ipbcp version identifies the types of IP bearer control protocol (IPBCP) message used in BICC (ITU-T Q.1901) environment that are limited to single-media payload. Refer to the pertinent ITU-T specifications while multiplexing. | S | SPECIAL
ITU-T H.248.15
ITU-T H.248.15 [H.248.15] defines the Gateway Control Protocol SDP H.248 package attribute.
ITU-T H.248.15 Attribute Analysis
Name | Notes | Level | Mux Category
h248item | It is only applicable for signaling the inclusion of H.248 extension packages to a gateway via the local and remote descriptors. The attribute itself is unaffected by multiplexing, but the package referenced in a specific use of the attribute can be impacted. Further analysis of each package is needed to determine if there is an issue. This is only a concern in environments using a decomposed server/gateway with H.248 signaled between them. The ITU-T will need to do further analysis of various packages when they specify how to signal the use of multiplexing to a gateway. | B | SPECIAL
RFC 4975: The Message Session Relay Protocol
[RFC4975] describes the Message Session Relay Protocol, a protocol for transmitting a series of related instant messages in the context of a session. Message sessions are treated like any other media stream when set up via a rendezvous or session-creation protocol such as the Session Initiation Protocol.
RFC 4975 Attribute Analysis
Name | Notes | Level | Mux Category
accept-types | Refer to notes below | M | TBD
accept-wrapped-types | Refer to notes below | M | TBD
max-size | Refer to notes below | M | TBD
path | Refer to notes below | M | TBD
NOTE: As per Section 9 of [RFC8843], there exists no publicly available specification that defines procedures for multiplexing/demultiplexing MSRP flows over a single 5-tuple. Once such a specification is available, the multiplexing categories assignments for the attributes in this section could be revisited.
Historical Attributes
This section specifies analysis for the attributes that are included for historic usage alone by the [IANA].
Historical Attribute Analysis
Name | Notes | Level | Mux Category
rtpred1 | Historic attributes | M | CAUTION
rtpred2 | Historic attributes | M | CAUTION
bwtype Attribute Analysis
This section specifies handling of specific bandwidth attributes when used in multiplexing scenarios.
RFC 4566: SDP
[RFC4566] defines SDP that is intended for describing multimedia sessions for the purposes of session announcement, session invitation, and other forms of multimedia session initiation.
RFC 4566 bwtype Analysis
Name | Notes | Level | Mux Category
bwtype:CT | Not impacted | S | NORMAL
bwtype:AS | For media-level usage, the aggregate of individual bandwidth values is considered. | B | SUM
RFC 3556: SDP Bandwidth Modifiers for RTCP Bandwidth
[RFC3556] defines an extension to SDP to specify two additional modifiers for the bandwidth attribute. These modifiers may be used to specify the bandwidth allowed for RTCP packets in an RTP session.
RFC 3556 bwtype Analysis
Name | Notes | Level | Mux Category
bwtype:RS | Session-level usage represents session aggregate, and media-level usage indicates SUM of the individual values while multiplexing. | B | SUM
bwtype:RR | Session-level usage represents session aggregate, and media-level usage indicates SUM of the individual values while multiplexing. | B | SUM
RFC 3890: Bandwidth Modifier for SDP
[RFC3890] defines SDP Transport Independent Application Specific Maximum (TIAS) bandwidth modifier that does not include transport overhead; instead, an additional packet-rate attribute is defined. The transport-independent bitrate value together with the maximum packet rate can then be used to calculate the real bitrate over the transport actually used.
RFC 3890 bwtype Analysis
Name | Notes | Level | Mux Category
bwtype:TIAS | The usage of TIAS is not defined under offer/answer usage. | B | SPECIAL
maxprate | The usage of TIAS and maxprate is not well defined under multiplexing. | B | SPECIAL
NOTE: The intention of TIAS is that the media-level bitrate is multiplied with the known per-packet overhead for the selected transport and the maxprate value to determine the worst-case bitrate from the transport to more accurately capture the required usage. Summing TIAS values independently across "m=" lines and multiplying the computed sum with maxprate and the per-packet overhead would inflate the value significantly. Instead, performing multiplication and adding the individual values is a more appropriate usage.
rtcp-fb Attribute Analysis
This section analyzes rtcp-fb SDP attributes.
RFC 4585: RTP/AVPF
[RFC4585] defines an extension to the Audio-Visual Profile (AVP) that enables receivers to provide, statistically, more immediate feedback to the senders; it thus allows for short-term adaptation and implementation of efficient feedback-based repair mechanisms.
RFC 4585 Attribute Analysis
Name | Notes | Level | Mux Category
ack rpsi | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
ack app | Feedback parameters MUST be handled in the app-specific way when multiplexed. | M | SPECIAL
nack | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
nack pli | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
nack sli | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
nack rpsi | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
nack app | Feedback parameters MUST be handled in the app specific way when multiplexed. | M | SPECIAL
trr-int | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 5104: Codec Control Messages in AVPF
[RFC5104] specifies a few extensions to the messages defined in the Audio-Visual Profile with Feedback (AVPF). They are helpful primarily in conversational multimedia scenarios where centralized multipoint functionalities are in use. However, some are also usable in smaller multicast environments and point-to-point calls.
RFC 5104 Attribute Analysis
Name | Notes | Level | Mux Category
ccm | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 6285: Unicast-Based Rapid Acquisition of Multicast RTP Sessions (RAMS)
[RFC6285] describes a method of using the existing RTP and RTCP machinery that reduces the acquisition delay. In this method, an auxiliary unicast RTP session carrying the Reference Information to the receiver precedes or accompanies the multicast stream. This unicast RTP flow can be transmitted at a faster-than-natural bitrate to further accelerate the acquisition. The motivating use case for this capability is multicast applications that carry real-time compressed audio and video.
RFC 6285 Attribute Analysis
Name | Notes | Level | Mux Category
nack rai | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 6679: ECN for RTP over UDP/IP
[RFC6679] specifies how Explicit Congestion Notification (ECN) can be used with the RTP running over UDP, using the RTCP as a feedback mechanism. It defines a new RTCP Extended Report (XR) block for periodic ECN feedback, a new RTCP transport feedback message for timely reporting of congestion events, and a STUN extension used in the optional initialization method using ICE.
RFC 6679 Attribute Analysis
Name | Notes | Level | Mux Category
ecn-capable-rtp | ECN markup is enabled at the RTP session level. | M | IDENTICAL
nack ecn | This attribute enables ECN at the RTP session level. | M | IDENTICAL
RFC 6642: Third-Party Loss Report
In a large RTP session using the RTCP feedback mechanism defined in [RFC4585], a feedback target may experience transient overload if some event causes a large number of receivers to send feedback at once. This overload is usually avoided by ensuring that feedback reports are forwarded to all receivers, allowing them to avoid sending duplicate feedback reports. However, there are cases where it is not recommended to forward feedback reports, and this may allow feedback implosion. [RFC6642] discusses these cases and defines a new RTCP Third-Party Loss Report that can be used to inform receivers that the feedback target is aware of some loss event, allowing them to suppress feedback. Associated SDP signaling is also defined.
RFC 6642 Attribute Analysis
Name | Notes | Level | Mux Category
nack tllei | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
nack pslei | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 5104: Codec Control Messages in AVPF
[RFC5104] specifies a few extensions to the messages defined in the Audio-Visual Profile with Feedback (AVPF). They are helpful primarily in conversational multimedia scenarios where centralized multipoint functionalities are in use. However, some are also usable in smaller multicast environments and point-to-point calls.
RFC 5104 Attribute Analysis
Name | Notes | Level | Mux Category
ccm fir | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
ccm tmmbr | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
ccm tstr | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
ccm vbcm | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
group Attribute Analysis
This section analyzes SDP "group" attribute semantics [RFC5888].
RFC 5888: SDP Grouping Framework
[RFC5888] defines a framework to group "m=" lines in SDP for different purposes.
RFC 5888 Attribute Analysis
Name | Notes | Level | Mux Category
group:LS | Not impacted | S | NORMAL
group:FID | Not impacted | S | NORMAL
RFC 3524: Mapping Media Streams to Resource Reservation Flows
[RFC3524] defines an extension to the SDP grouping framework. It allows requesting a group of media streams to be mapped into a single resource reservation flow. The SDP syntax needed is defined, as well as a new "semantics" attribute called Single Reservation Flow (SRF).
RFC 3524 Attribute Analysis
Name | Notes | Level | Mux Category
group:SRF | Not impacted | S | NORMAL
RFC 4091: ANAT Semantics
[RFC4091] defines ANAT semantics for the SDP grouping framework. (Note: [RFC4091] has been obsoleted by [RFC8445].) The ANAT semantics allow alternative types of network addresses to establish a particular media stream.
RFC 4091 Attribute Analysis
Name | Notes | Level | Mux Category
group:ANAT | ANAT semantics is obsoleted. | S | CAUTION
RFC 5956: FEC Grouping Semantics in SDP
[RFC5956] defines the semantics for grouping the associated source and FEC-based repair flows in SDP. The semantics defined in the document are to be used with the SDP Grouping Framework [RFC5888]. These semantics allow the description of grouping relationships between the source and repair flows when one or more source and/or repair flows are associated in the same group; they also provide support for additive repair flows. SSRC-level grouping semantics are also defined in this document for RTP streams using SSRC multiplexing.
RFC 5956 Attribute Analysis
Name | Notes | Level | Mux Category
group:FEC-FR | Not impacted | S | NORMAL
RFC 5583: Signaling Media Decoding Dependency in SDP
[RFC5583] defines semantics that allow for signaling the decoding dependency of different media descriptions with the same media type in SDP. This is required, for example, if media data is separated and transported in different network streams as a result of using a layered or multiple descriptive media coding process.
RFC 5583 Attribute Analysis
Name | Notes | Level | Mux Category
group:DDP | Not impacted | S | NORMAL
depend lay | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
depend mdc | The attribute value MUST be the same for a given codec configuration. | M | IDENTICAL-PER-PT
RFC 7104: Duplication Grouping Semantics in the SDP
[RFC7104] defines the semantics for grouping redundant streams in SDP. The semantics defined in this document are to be used with the SDP Grouping Framework. Grouping semantics at the synchronization source (SSRC) level are also defined in this document for RTP streams using SSRC multiplexing.
RFC 7104 Attribute Analysis
Name | Notes | Level | Mux Category
group:DUP | Not impacted | S | NORMAL
ssrc-group Attribute Analysis
This section analyzes "ssrc-group" semantics.
RFC 5576: Source-Specific SDP Attributes
[RFC5576] defines a mechanism for describing RTP media sources -- which are identified by their synchronization source (SSRC) identifiers -- in SDP, to associate attributes with these sources and express relationships among sources. It also defines several source-level attributes that can be used to describe properties of media sources.
RFC 5576 Attribute Analysis
Name | Notes | Level | Mux Category
ssrc-group:FID | Not impacted | SR | NORMAL
ssrc-group:FEC | Not impacted | SR | NORMAL
ssrc-group:FEC-FR | Not impacted | SR | NORMAL
RFC 7104: Duplication Grouping Semantics in the SDP
[RFC7104] defines the semantics for grouping redundant streams in SDP. The semantics defined in this document are to be used with the SDP Grouping Framework. Grouping semantics at the synchronization source (SSRC) level are also defined in this document for RTP streams using SSRC multiplexing.
RFC 7104 Attribute Analysis
Name | Notes | Level | Mux Category
ssrc-group:DUP | Not impacted | SR | NORMAL
QoS Mechanism Token Analysis
This section analyzes QoS tokes specified with SDP.
RFC 5432: QoS Mechanism Selection in SDP
[RFC5432] defines procedures to negotiate QoS mechanisms using the SDP offer/answer model.
RFC 5432 Attribute Analysis
Name | Notes | Level | Mux Category
rsvp | rsvp attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport flow. | B | TRANSPORT
nsis | rsvp attribute MUST be the one that corresponds to the "m=" line chosen for setting up the underlying transport. | B | TRANSPORT
NOTE: A single Differentiated Services Code Point (DSCP) for each flow being multiplexed doesn't impact multiplexing, since QoS mechanisms are signaled/scoped per flow. For scenarios that involve having different DSCP code points for packets being transmitted over the same 5-tuple, issues as discussed in [RFC7657] need to be taken into consideration.
k= Attribute Analysis
RFC 4566: SDP
[RFC4566] defines SDP that is intended for describing multimedia sessions for the purposes of session announcement, session invitation, and other forms of multimedia session initiation.
RFC 4566 Attribute Analysis
Name | Notes | Level | Mux Category
k= | It is not recommended to use this attribute under multiplexing. | S | CAUTION
content Attribute Analysis
RFC 4796
[RFC4796] defines a new SDP media-level attribute, "content". The "content" attribute defines the content of the media stream to a more detailed level than the media-description line. The sender of an SDP session description can attach the "content" attribute to one or more media streams. The receiving application can then treat each media stream differently (e.g., show it on a big or small screen) based on its content.
RFC 4796 Attribute Analysis
Name | Notes | Level | Mux Category
content:slides | Not impacted | M | NORMAL
content:speaker | Not impacted | M | NORMAL
content:main | Not impacted | M | NORMAL
content:sl | Not impacted | M | NORMAL
content:alt | Not impacted | M | NORMAL
Payload Formats
RFC 5109: RTP Payload Format for Generic FEC
[RFC5109] describes a payload format for generic Forward Error Correction (FEC) for media data encapsulated in RTP. It is based on the exclusive-or (parity) operation. The payload format allows end systems to apply protection using various protection lengths and levels, in addition to using various protection group sizes to adapt to different media and channel characteristics. It enables complete recovery of the protected packets or partial recovery of the critical parts of the payload, depending on the packet loss situation.
RFC 5109 Payload Format Analysis
Name | Notes | Level | Mux Category
audio/ulpfec | Not recommended for multiplexing due to reuse of SSRCs. | M | CAUTION
video/ulpfec | Not recommended for multiplexing due to reuse of SSRCs. | M | CAUTION
text/ulpfec | Not recommended for multiplexing due to reuse of SSRCs. | M | CAUTION
application/ulpfec | Not recommended for multiplexing due to reuse of SSRCs. | M | CAUTION
Multiplexing Considerations for Encapsulating Attributes
This section deals with recommendations for defining the multiplexing characteristics of the SDP attributes that encapsulate other SDP attributes/parameters. As of today, such attributes, for example, are defined in [RFC3407], [RFC5939] and [RFC6871] as part of a generic framework for indicating and negotiating transport-, media-, and media-format-related capabilities in the SDP.
The behavior of such attributes under multiplexing is, in turn, defined by the multiplexing behavior of the attributes they encapsulate, which are made known once the offer/answer negotiation process is completed.
RFC 3407: cpar Attribute Analysis
The [RFC3407] capability parameter attribute "a=cpar" encapsulates a "b=" (bandwidth) or an "a=" attribute. For bandwidth attribute encapsulation, the category SUM is inherited. For the case of "a=" attribute, the category corresponding to the SDP attribute being encapsulated is inherited.

 v=0
 o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
 s=
 c=IN IP4 host.atlanta.example.com
 t=0 0
 m=video 3456 RTP/AVP 100
 a=rtpmap:100 VP8/90000
 a=sqn: 0
 a=cdsc: 1 video RTP/AVP 100
 a=cpar: a=rtcp-mux
 m=video 3456 RTP/AVP 101
 a=rtpmap:101 VP8/90000
 a=fmtp:100 max-fr=15;max-fs=1200
 a=cdsc: 2 video RTP/AVP 101
 a=cpar: a=rtcp-mux
In this example, the category IDENTICAL is inherited for the cpar-encapsulated "rtcp-mux" attribute.
RFC 5939 Analysis
[RFC5939] defines a general SDP capability negotiation framework. It also specifies how to provide transport protocols and SDP attributes as capabilities and negotiate them using the framework.
For this purpose, [RFC5939] defines the following:
- A set of capabilities for the session and its associated media-stream components, supported by each side. The attribute "a=acap" defines how to list an attribute name and its associated value (if any) as a capability. The attribute "a=tcap" defines how to list transport protocols (e.g., "RTP/AVP") as capabilities.
- A set of potential configurations ("a=pcfg") provided by the offerer to indicate which combinations of those capabilities can be used for the session and its associated media stream components. Potential configurations are not ready for use until fully negotiated. They provide an alternative that MAY be used, subject to SDP capability-negotiation procedures. In particular, the answerer MAY choose one of the potential configurations for use as part of the current offer/answer exchange.
- An actual configuration ("a=acfg") for the session and its associated media stream components. The actual configuration identifies the potential configuration that was negotiated for use. Use of an actual configuration does not require any further negotiation.
- A negotiation process that takes the current actual and the set of potential configurations (combinations of capabilities) as input and provides the negotiated actual configurations as output. In [RFC5939], the negotiation process is done independently for each media description.
Recommendation: Procedures for Potential Configuration Pairing
This section provides recommendations for entities generating and processing SDP under the generic capability-negotiation framework as defined in [RFC5939] under the context of media-stream multiplexing.
These recommendations are provided for the purposes of enabling the offerer to make sure that the generated potential configurations between the multiplexed streams can (easily) be negotiated to be consistent between those streams. In particular, the procedures aim to simplify the answerer's procedure for choosing potential configurations that are consistent across all the multiplexed media descriptions.
A potential configuration selects a set of attributes and parameters that become part of the media description when negotiated. When multiplexing media descriptions with potential configurations specified, there MAY be a need for coordinating this selection between multiplexed media descriptions to ensure the right multiplexing behavior.
Although it is possible to analyze the various potential configurations in multiplexed media descriptions to find combinations that satisfy such constraints, it can quickly become complicated to do so.
The procedures defined in [RFC5939] state that each potential configuration in the SDP has a unique configuration number; however, the scope of uniqueness is limited to each media description. To make it simple for the answerer to chose valid combinations of potential configurations across media descriptions in a given bundle group, we provide a simple rule for constructing potential configurations:
- Let m-bundle be the set of media descriptions that form a given bundle.
- Let m-bundle-pcfg be the set of media descriptions in m-bundle that include one or more potential configurations.
- Each media description in m-bundle-pcfg MUST have at least one potential configuration with the same configuration number (e.g., "1").
- For each potential configuration with configuration number x in m-bundle-pcfg, the offerer MUST ensure that if the answerer chooses configuration number x in each of the media descriptions in m-bundle-pcfg, then the resulting SDP will have all multiplexing constraints satisfied for those media descriptions.
- Since it is nearly impossible to define a generic mechanism for various capability extensions, this document doesn't provide procedures for dealing with the capability-extension attributes. However, Section 14.3 provides analysis of media-capability-extension attributes as defined in [RFC6871].
The above allows the answerer to easily find multiplexing-compatible combinations of potential configurations. The answerer simply chooses a potential configuration (number) that is present in all of the media descriptions with potential configurations in the bundle.
Note that it is still possible for the offerer to provide additional potential configurations with independent configuration numbers. The answerer will have to perform more complicated analysis to determine valid multiplexed combinations of those.
Example: Transport-Capability Multiplexing

v=0
o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
s=
c=IN IP4 host.atlanta.example.com
t=0 0
a=tcap:1 RTP/SAVPF
a=tcap:2 RTP/SAVP
a=group:BUNDLE audio video
m=audio
a=mid:audio
a=pcfg:1 t=1
a=pcfg:2
m=video
a=mid:video
a=pcfg:1 t=1
a=pcfg:2 t=2

In this example, the potential configurations that offer transport-protocol capability of RTP/SAVPF have the same configuration number "1" in both the audio and video media descriptions.
Example: Attribute-Capability Multiplexing

v=0
o=alice 2890844526 2890844527 IN IP4 host.atlanta.example.com
s=
c=IN IP4 host.atlanta.example.com
t=0 0
a=acap:1 a=rtcp-mux
a=acap:2 a=crypto:1 AES_CM_128_HMAC_SHA1_80
  inline:EcGZiNWpFJhQXdspcl1ekcmVCNWpVLcfHAwJSoj|2^20|1:32
a=group:BUNDLE audio video
m=audio 49172 RTP/AVP 99
a=mid:audio
a=pcfg:1 a=1
a=pcfg:2
m=video 560024 RTP/AVP 100
a=mid:video
a=pcfg:1 a=1
a=pcfg:2 a=2

In this example, the potential configuration number "1" is repeated while referring to attribute capability a=rtcp-mux, since the behavior is IDENTICAL for the attribute a=rtcp-mux under multiplexing.
RFC 6871 Analysis
[RFC6871] extends the capability negotiation framework described in [RFC5939] by defining media capabilities that can be used to indicate and negotiate media types and their associated format parameters. It also allows indication of latent configurations and session capabilities.
Recommendation: Dealing with Payload Type Numbers
[RFC6871] defines a new payload type parameter ("pt") to be used with the potential, actual, and latent configuration parameters. The parameter associates RTP payload type numbers with the referenced RTP-based media-format capabilities ("a=rmcap") defined in [RFC6871] and is appropriate only when the transport protocol uses RTP. This means that the same payload type number can be assigned as part of potential or actual configurations in different media descriptions in a bundle. There are rules for the usage of identical payload type values across multiplexed "m=" lines, described in [RFC8843], which must be followed here, as well. As described in Section 14.2.1, the use of identical configuration numbers for compatible configurations in different media descriptions that are part of the bundle provides a way to ensure that the answerer can easily pick compatible configurations here, as well.
Example: Attribute Capability under Shared Payload Type
The attributes "a=rmcap" and "a=mfcap" follow the above recommendations under multiplexing.

v=0
o=- 25678 753849 IN IP4 192.0.2.1
s=
c=IN IP4 192.0.2.1
t=0 0
a=creq:med-v0
m=audio 54322 RTP/AVP 96
a=rtpmap:96 AMR-WB/16000/1
a=fmtp:96 mode-change-capability=1; max-red=220;
mode-set=0,2,4,7
a=rmcap:1,3 audio AMR-WB/16000/1
a=rmcap:2 audio AMR/8000/1
a=mfcap:1,2 mode-change-capability=1
a=mfcap:3 mode-change-capability=2
a=pcfg:1 m=1 pt=1:96
a=pcfg:2 m=2 pt=2:97
a=pcfg:3 m=3 pt=3:98
m=audio 54322 RTP/AVP 96
a=rtpmap:96 AMR-WB/16000/1
a=fmtp:96 mode-change-capability=1; max-red=220;
mode-set=0,2,4,7
a=rmcap:4 audio AMR/8000/1
a=rmcap:5 audio OPUS/48000/2
a=mfcap:5 minptime=40
a=mfcap:4 mode-change-capability=1
a=pcfg:1 m=4 pt=4:97
a=pcfg:4 m=5 pt=5:101

In this example, the potential configuration number "1" is repeated when referring to media and media-format capability used for the Payload Type 96. This implies that both media capabilities 2 and 4, along with their media-format capabilities, MUST refer to the same codec configuration, as per the definition of IDENTICAL-PER-PT.
Recommendation: Dealing with Latent Configurations
[RFC6871] adds the notion of a latent configuration that provides configuration information that may be used to guide a subsequent offer/exchange -- e.g., by adding another media stream or using alternative codec combinations not currently offered. Latent configurations have configuration numbers that cannot overlap with the potential configuration numbers [RFC6871]. Supported combinations of potential and latent configurations are indicated by use of the "a=sescap" attribute; however, use of this attribute is not recommended with multiplexed media, since it requires the use of unique configuration numbers across the SDP. Taken together, this means there is no well-defined way to indicate supported combinations of latent configurations, or combinations of latent and potential configurations with multiplexed media. It is still allowed to use the latent configuration attribute; however, the limitations above will apply. To determine valid combinations, actual negotiation will have to be attempted subsequently instead.
IANA Considerations
Section 15.1 defines a new subregistry, which has been added by the IANA, for identifying the initial registrations for various multiplexing categories applicable, as described in this document.
IANA has added a new column named "Mux Category" to several of the subregistries in the "Session Description Protocol (SDP) Parameters" registry. The tables in Section 15.2 identify the names of entries in the existing subregistry and specify the value to be put in the new "Mux Category" column of the associated IANA registry for each.
New "Multiplexing Categories" Subregistry
A new subregistry has been created. It is called "Multiplexing Categories" and has the following registrations initially:
Multiplexing Categories | Reference
NORMAL | RFC 8859
CAUTION | RFC 8859
IDENTICAL | RFC 8859
TRANSPORT | RFC 8859
SUM | RFC 8859
INHERIT | RFC 8859
IDENTICAL-PER-PT | RFC 8859
SPECIAL | RFC 8859
TBD | RFC 8859
Further entries can be registered using Standard Actions policies outlined in [RFC8126], which requires IESG review and approval and Standards Track IETF RFC publication.
Each registration needs to indicate the multiplexing category value to be added to the "Multiplexing Categories" subregistry, as defined in this section.
Such a registration MUST also indicate the applicability of the newly defined multiplexing category value to various subregistries defined in the "Session Description Protocol (SDP) Parameters" registry.
"Mux Category" Column for Subregistries
Each subsection identifies a subregistry of the "Session Description Protocol (SDP) Parameters" registry. The tables list the column that identifies the SDP attribute name/Token/Value from the corresponding subregistries and the values to be used for the new "Mux Category" column to be added.
Entries in the existing subregistries of the "Session Description Protocol (SDP) Parameters" registry that lack a value for the "Mux Category" in this specification will get a value of "TBD".
The registration policy for updates to the "Mux Category" column values for existing parameters, or when registering new parameters, is beyond the scope of this document. The registration policy for the affected table is defined in [SDP].
Table: SDP bwtype
The following values have been added to the "bwtype" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
SDP Name | Mux Category
CT | NORMAL
AS | SUM
RS | SUM
RR | SUM
TIAS | SPECIAL
Table: att-field
The following values have been added to the "att-field" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
NOTE: The attributes from [FLUTE] ("flute-tsi", "flute-ch", "FEC-declaration", "FEC-OTI-extension", "content-desc") were not analyzed for their multiplexing behavior, due to the expired status of the draft. For the purposes of this specification, the multiplexing category of "TBD" is assigned.
SDP Name | Mux Category
cat | NORMAL
keywds | NORMAL
type | NORMAL
type:broadcast | NORMAL
type:H332 | NORMAL
type:meeting | NORMAL
type:moderated | NORMAL
type:test | NORMAL
charset | NORMAL
charset:iso8895-1 | NORMAL
tool | NORMAL
ipbcp | SPECIAL
group | NORMAL
ice-lite | NORMAL
ice-options | NORMAL
bcastversion | NORMAL
3GPP-Integrity-Key | CAUTION
3GPP-SDP-Auth | CAUTION
alt-group | CAUTION
PSCid | NORMAL
bc_service | NORMAL
bc_program | NORMAL
bc_service_package | NORMAL
sescap | CAUTION
rtsp-ice-d-m | TBD
recvonly | NORMAL
sendrecv | NORMAL
sendonly | NORMAL
sdplang | NORMAL
lang | NORMAL
h248item | SPECIAL
sqn | NORMAL
cdsc | NORMAL
cpar | INHERIT
cparmin | SPECIAL
cparmax | SPECIAL
rtcp-xr | NORMAL
maxprate | SPECIAL
setup | TRANSPORT
connection | TRANSPORT
key-mgmt | IDENTICAL
source-filter | IDENTICAL
inactive | NORMAL
fingerprint | TRANSPORT
flute-tsi | TBD
flute-ch | TBD
FEC-declaration | TBD
FEC-OTI-extension | TBD
content-desc | TBD
ice-pwd | TRANSPORT
ice-ufrag | TRANSPORT
stkmstream | NORMAL
extmap | SPECIAL
qos-mech-send | TRANSPORT
qos-mech-recv | TRANSPORT
csup | NORMAL
creq | NORMAL
acap | INHERIT
tcap | INHERIT
3GPP-QoE-Metrics | CAUTION
3GPP-Asset-Information | CAUTION
mbms-mode | CAUTION
mbms-repair | CAUTION
ike-setup | IDENTICAL
psk-fingerprint | IDENTICAL
multicast-rtcp | IDENTICAL
rmcap | IDENTICAL-PER-PT
omcap | NORMAL
mfcap | IDENTICAL-PER-PT
mscap | INHERIT
3gpp.iut.replication | TBD
bcap | INHERIT
ccap | IDENTICAL
icap | NORMAL
etag | CAUTION
duplication-delay | NORMAL
range | CAUTION
control | CAUTION
mtag | CAUTION
ts-refclk | NORMAL
mediaclk | NORMAL
calgextmap | NORMAL
ptime | IDENTICAL-PER-PT
orient | NORMAL
orient:portrait | NORMAL
orient:landscape | NORMAL
orient:seascape | NORMAL
framerate | IDENTICAL-PER-PT
quality | NORMAL
rtpmap | IDENTICAL-PER-PT
fmtp | IDENTICAL-PER-PT
rtpred1 | CAUTION
rtpred2 | CAUTION
T38FaxVersion | TBD
T38MaxBitRate | TBD
T38FaxFillBitRemoval | TBD
T38FaxTranscodingMMR | TBD
T38FaxTranscodingJBIG | TBD
T38FaxRateManagement | TBD
T38FaxMaxBuffer | TBD
T38FaxMaxDatagram | TBD
T38FaxUdpEC | TBD
maxptime | IDENTICAL-PER-PT
des | CAUTION
curr | CAUTION
conf | CAUTION
mid | NORMAL
rtcp | TRANSPORT
rtcp-fb | IDENTICAL-PER-PT
label | NORMAL
T38VendorInfo | TBD
crypto | TRANSPORT
eecid | CAUTION
aalType | CAUTION
capability | CAUTION
qosClass | CAUTION
bcob | CAUTION
stc | CAUTION
upcc | CAUTION
atmQOSparms | CAUTION
atmTrfcDesc | CAUTION
abrParms | CAUTION
abrSetup | CAUTION
bearerType | CAUTION
lij | CAUTION
anycast | CAUTION
cache | CAUTION
bearerSigIE | CAUTION
aalApp | CAUTION
cbrRate | CAUTION
sbc | CAUTION
clkrec | CAUTION
fec | CAUTION
prtfl | CAUTION
structure | CAUTION
cpsSDUsize | CAUTION
aal2CPS | CAUTION
aal2CPSSDUrate | CAUTION
aal2sscs3661unassured | CAUTION
aal2sscs3661assured | CAUTION
aal2sscs3662 | CAUTION
aal5sscop | CAUTION
atmmap | CAUTION
silenceSupp | CAUTION
ecan | CAUTION
gc | CAUTION
profileDesc | CAUTION
vsel | CAUTION
dsel | CAUTION
fsel | CAUTION
onewaySel | CAUTION
codecconfig | CAUTION
isup_usi | CAUTION
uiLayer1_Prot | CAUTION
chain | CAUTION
floorctrl | TBD
confid | TBD
userid | TBD
floorid | TBD
FEC | NORMAL
accept-types | TBD
accept-wrapped-types | TBD
max-size | TBD
path | TBD
dccp-service-code | CAUTION
rtcp-mux | IDENTICAL
candidate | TRANSPORT
ice-mismatch | NORMAL
remote-candidates | TRANSPORT
SRTPAuthentication | TBD
SRTPROCTxRate | TBD
rtcp-rsize | IDENTICAL
file-selector | TBD
file-transfer-id | TBD
file-disposition | TBD
file-date | TBD
file-icon | TBD
file-range | TBD
depend | IDENTICAL-PER-PT
ssrc | NORMAL
ssrc-group | NORMAL
rtcp-unicast | IDENTICAL
pcfg | SPECIAL
acfg | SPECIAL
zrtp-hash | TRANSPORT
X-predecbufsize | CAUTION
X-initpredecbufperiod | CAUTION
X-initpostdecbufperiod | CAUTION
X-decbyterate | CAUTION
3gpp-videopostdecbufsize | CAUTION
framesize | CAUTION
3GPP-SRTP-Config | CAUTION
alt | CAUTION
alt-default-id | CAUTION
3GPP-Adaption-Support | CAUTION
mbms-flowid | CAUTION
fec-source-flow | SPECIAL
fec-repair-flow | SPECIAL
repair-window | SPECIAL
rams-updates | CAUTION
imageattr | IDENTICAL-PER-PT
cfw-id | NORMAL
portmapping-req | CAUTION
g.3gpp.crs | NORMAL
ecn-capable-rtp | IDENTICAL
visited-realm | TRANSPORT
secondary-realm | TRANSPORT
omr-s-cksum | NORMAL
omr-m-cksum | NORMAL
omr-codecs | NORMAL
omr-m-att | NORMAL
omr-s-att | NORMAL
omr-m-bw | NORMAL
omr-s-bw | NORMAL
msrp-cema | TBD
dccp-port | CAUTION
resource | NORMAL
channel | NORMAL
cmid | NORMAL
content | NORMAL
lcfg | SPECIAL
loopback | NORMAL
loopback-source | NORMAL
loopback-mirror | NORMAL
chatroom | TBD
altc | TRANSPORT
T38FaxMaxIFP | TBD
T38FaxUdpECDepth | TBD
T38FaxUdpFECMaxSpan | TBD
T38ModemType | TBD
cs-correlation | TBD
rtcp-idms | NORMAL
cname | NORMAL
previous-ssrc | NORMAL
fmtp | IDENTICAL-PER-PT
ts-refclk | NORMAL
mediaclk | NORMAL
Table: content SDP Parameters
The following values have been added to the "content SDP Parameters" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
SDP Name | Mux Category
slides | NORMAL
speaker | NORMAL
sl | NORMAL
main | NORMAL
alt | NORMAL
g.3gpp.cat | NORMAL
Table: Semantics for the "group" SDP Attribute
The following values have been added to the "Semantics for the 'group' SDP Attribute" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Token | Mux Category
LS | NORMAL
FID | NORMAL
SRF | NORMAL
ANAT | CAUTION
FEC | NORMAL
FEC-FR | NORMAL
CS | NORMAL
DDP | NORMAL
DUP | NORMAL
Table: "rtcp-fb" Attribute Values
The following values have been added to the "'rtcp-fb' Attribute Values" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Value Name | Mux Category
ack | IDENTICAL-PER-PT
app | SPECIAL
ccm | IDENTICAL-PER-PT
nack | IDENTICAL-PER-PT
trr-int | IDENTICAL-PER-PT
Table: "ack" and "nack" Attribute Values
The following values have been added to the "'ack' and 'nack' Attribute Values" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Value Name | Mux Category
sli | IDENTICAL-PER-PT
pli | IDENTICAL-PER-PT
rpsi | IDENTICAL-PER-PT
app | SPECIAL
rai | IDENTICAL-PER-PT
tllei | IDENTICAL-PER-PT
pslei | IDENTICAL-PER-PT
ecn | IDENTICAL
Table: "depend" SDP Attribute Values
The following values have been added to the "'depend' SDP Attribute Values" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Token | Mux Category
lay | IDENTICAL-PER-PT
mdc | IDENTICAL-PER-PT
Table: "cs-correlation" Attribute Values
The following values have been added to the "'cs-correlation' Attribute Values" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Value | Mux Category
callerid | TBD
uuie | TBD
dtmf | TBD
external | TBD
Table: Semantics for the "ssrc-group" SDP Attribute
The following values have been added to the "Semantics for the 'ssrc-group' SDP Attribute" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Token | Mux Category
FID | NORMAL
FEC | NORMAL
FEC-FR | NORMAL
DUP | NORMAL
Table: SDP/RTSP Key Management Protocol Identifiers
The following values have been added to the "SDP/RTSP key management protocol identifiers" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Value Name | Mux Category
mikey | IDENTICAL
Table: Codec Control Messages
The following values have been added to the "Codec Control Messages" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Value Name | Mux Category
fir | IDENTICAL-PER-PT
tmmbr | IDENTICAL-PER-PT
tstr | IDENTICAL-PER-PT
vbcm | IDENTICAL-PER-PT
Table: QoS Mechanism Tokens
The following values have been added to the "QoS Mechanism Tokens" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
QoS Mechanism | Mux Category
rsvp | TRANSPORT
nsis | TRANSPORT
Table: SDP Capability Negotiation Option Tags
The following values have been added to the "SDP Capability Negotiation Option Tags" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Option Tag | Mux Category
cap-v0 | NORMAL
med-v0 | NORMAL
bcap-v0 | NORMAL
ccap-v0 | NORMAL
icap-v0 | NORMAL
Table: Timestamp Reference Clock Source Parameters
The following values have been added to the "Timestamp Reference Clock Source Parameters" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Name | Mux Category
ntp | NORMAL
ptp | NORMAL
gps | NORMAL
gal | NORMAL
glonass | NORMAL
local | NORMAL
private | NORMAL
Table: Media Clock Source Parameters
The following values have been added to the "Media Clock Source Parameters" subregistry of the "Session Description Protocol (SDP) Parameters" registry. The references have been updated to point to this RFC as well as the previous references.
Name | Mux Category
sender | NORMAL
direct | NORMAL
IEEE1722 | NORMAL
Security Considerations
The primary security considerations for RTP, including the way it is used here, are described in [RFC3550] and [RFC3711].
When multiplexing SDP attributes with the category "CAUTION", the implementations should be aware of possible issues described in this specification.
References
Normative References
[RFC8843]

Negotiating Media Multiplexing Using the Session Description Protocol (SDP)
Christer Holmberg
Harald Alvestrand
Cullen Jennings
April 2020
RFC 8843
DOI 10.17487/RFC8843
Informative References
[SDP]

SDP: Session Description Protocol
Work in Progress, draft-ietf-mmusic-rfc4566bis-35
Ali Begen
Paul Kyzivat
Colin Perkins
Mark Handley
3 May 2019
[IANA]

Session Description Protocol (SDP) Parameters
IANA
[T.38]

Procedures for real-time Group 3 facsimile communication over IP networks
ITU-T Recommendation T.38
ITU-T
November 2015
[H.248.15]

Gateway control protocol: SDP ITU-T H.248 package attribute
ITU-T Recommendation H.248.15
ITU-T
March 2013
[Q.1970]

Q.1970: BICC IP bearer control protocol
ITU-T Recommendation Q.1970
ITU-T
September 2006
[IP-CALL]

IP multimedia call control protocol based on Session Initiation Protocol (SIP) and Session Description Protocol (SDP); Stage 3
Specification 24.229
3GPP
September 2016
[TISPAN]

Telecommunications and Internet converged Services and Protocols for Advanced Networking (TISPAN); IMS-based IPTV stage 3 specification
Technical Specification 183 063 V2.1.0
ETSI
June 2008
[IMS-CAT]

IP Multimedia Subsystem (IMS) Customized Alerting Tones (CAT); Protocol specification
Specification 24.182
3GPP
January 2015
Specification 24.182
[IMS-CRS]

IP Multimedia Subsystem (IMS) Customized Ringing Signal (CRS); Protocol specification
3GPP
September 2016
Specification 24.183
[FLUTE]

SDP Descriptors for FLUTE
Work in Progress, draft-ietf-rmt-flute-sdp-03
Rod Walsh
Jani Peltotalo
Sami Peltotalo
Igor Curcio
Harsh Mehta
12 September 2012
[RFC8856]

Session Description Protocol (SDP) Format for Binary Floor Control Protocol (BFCP) Streams
Gonzalo Camarillo
Tom Kristensen
Christer Holmberg
May 2020
RFC 8856
DOI 10.17487/RFC8856
[RFC8445]
[RFC2119]
[RFC8174]
[RFC5763]
[RFC5888]
[RFC5762]
[RFC3407]
[RFC5939]
[RFC6871]
[RFC5285]
[RFC5576]
[RFC4566]
[RFC4585]
[RFC5761]
[RFC3312]
[RFC4574]
[RFC5432]
[RFC4568]
[RFC6773]
[RFC5506]
[RFC6787]
[RFC8285]
[RFC3605]
[RFC7273]
[RFC6236]
[RFC7197]
[RFC7266]
[RFC6285]
[RFC6230]
[RFC6364]
[RFC4796]
[RFC6284]
[RFC6714]
[RFC4583]
[RFC5547]
[RFC3264]
[RFC6849]
[RFC5760]
[RFC3611]
[RFC7006]
[RFC4567]
[RFC4572]
[RFC8122]
[RFC4570]
[RFC6128]
[RFC6189]
[RFC4145]
[RFC6947]
[RFC7195]
[RFC7272]
[RFC5159]
[RFC6193]
[RFC2326]
[RFC6064]
[RFC3108]
[RFC4975]
[RFC3556]
[RFC3890]
[RFC5104]
[RFC6679]
[RFC6642]
[RFC3524]
[RFC4091]
[RFC5956]
[RFC5583]
[RFC7104]
[RFC7657]
[RFC5109]
[RFC8126]
[RFC3550]
[RFC3711]
Acknowledgements
I would like to thank Cullen Jennings and Flemming Andreasen for suggesting the categories, contributing text, and reviewing the draft of this document. I would also like to thank Magnus Westerlund, Christer Holmberg, Jonathan Lennox, Bo Burman, Ari Keranen, and Dan Wing for suggesting structural changes that improved the document's readability.
I would like also to thank the following experts for their inputs and reviews as listed:
Option A
- Flemming Andreasen (5.24, 5.32, 5.33, 14),
- Rohan Mahy (5.56),
- Eric Burger (5.26),
- Christian Huitema (5.14),
- Christer Holmberg (5.21, 5.26, 5.50, 5.51),
- Richard Ejzak (5.44, 5.52, 5.53),
- Colin Perkins (5.7, 5.8, 5.9, 5.57),
- Magnus Westerlund (5.2, 5.3, 5.9, 5.27, 5.47, 6.1 - 6.3, 8.3, 7),
- Roni Evens (5.12, 5.27, 8.4),
- Subha Dhesikan (5.6, 10),
- Dan Wing (5.7, 5.12, 5.35, 5.39, 5.45),
- Cullen Jennings (5.40),
- Ali C Begen (5.1, 5.20, 5.22, 5.25, 5.38, 7.3, 8.2, 8.4, 8.6, 9.2, 13.1),
- Bo Burman (7.2, 7.6),
- Charles Eckel (5.15, 5.27, 5.28, 9.1, 8.5),
- Paul Kyzivat (5.24),
- Ian Johansson (5.15),
- Saravanan Shanmugham (5.11),
- Paul E Jones (5.30),
- Rajesh Kumar (5.48),
- Jonathan Lennox (5.36, 5, 15, 9.1, 11.1),
- Mo Zanaty (5.4, 5.5, 5.23, 8.1, 8.3, 8.5, 12.1),
- Christian Huitema (5.14),
- Qin Wu (5.47, PM-Dir review),
- Hans Stokking (5.43, 5.16),
- Christian Groves (5.48, 5.54), and
- Thomas Stach.
Option B
- Flemming Andreasen (5.24, 5.32, 5.33, 14),
Rohan Mahy (5.56),
Eric Burger (5.26),
Christian Huitema (5.14),
Christer Holmberg (5.21, 5.26, 5.50, 5.51),
Richard Ejzak (5.44, 5.52, 5.53),
Colin Perkins (5.7, 5.8, 5.9, 5.57),
Magnus Westerlund (5.2, 5.3, 5.9, 5.27, 5.47, 6.1 - 6.3, 8.3, 7),
Roni Evens (5.12, 5.27, 8.4),
Subha Dhesikan (5.6, 10),
Dan Wing (5.7, 5.12, 5.35, 5.39, 5.45),
Cullen Jennings (5.40),
Ali C Begen (5.1, 5.20, 5.22, 5.25, 5.38, 7.3, 8.2, 8.4, 8.6, 9.2, 13.1),
Bo Burman (7.2, 7.6),
Charles Eckel (5.15, 5.27, 5.28, 9.1, 8.5),
Paul Kyzivat (5.24),
Ian Johansson (5.15),
Saravanan Shanmugham (5.11),
Paul E Jones (5.30),
Rajesh Kumar (5.48),
Jonathan Lennox (5.36, 5, 15, 9.1, 11.1),
Mo Zanaty (5.4, 5.5, 5.23, 8.1, 8.3, 8.5, 12.1),
Christian Huitema (5.14),
Qin Wu (5.47, PM-Dir review),
Hans Stokking (5.43, 5.16),
Christian Groves (5.48, 5.54), and
Thomas Stach.
I would like to thank Chris Lonvick for the SECDIR review, Dan Romascanu for the Gen-ART review, and Sabrina Tanamal for the IANA review.
Thanks to Ben Campbell for Area Director review suggestions. Thanks to Spencer Dawkins, Stephen Farrel, Alissa Cooper, Mirja Kühlewind, and the entire IESG for their reviews.